## libnitrokey 3.2

=== CMakeLists.txt ===
# https://cmake.org/pipermail/cmake/2011-May/044166.html
IF(NOT DEFINED CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS)
    SET(CMAKE_INSTALL_SYSTEM_RUNTIME_LIBS_NO_WARNINGS ON)
ENDIF()

cmake_minimum_required(VERSION 3.1)
IF (UNIX)
    OPTION(ADD_ASAN "Use ASAN to show memory issues" FALSE)
    OPTION(ADD_TSAN "Use TSAN to show thread issues" FALSE)
    IF(ADD_ASAN)
        SET(EXTRA_LIBS ${EXTRA_LIBS} asan )
        ADD_COMPILE_OPTIONS(-fsanitize=address -fno-omit-frame-pointer)
    ENDIF()
    IF(ADD_TSAN)
        SET(EXTRA_LIBS ${EXTRA_LIBS} tsan )
        SET(USE_CLANG TRUE)
        ADD_COMPILE_OPTIONS(-fsanitize=thread -fno-omit-frame-pointer -fPIC -g) #use with clang
    ENDIF()
    IF(ADD_TSAN AND ADD_ASAN)
        message(FATAL_ERROR "TSAN and ASAN cannot be used at the same time")
    ENDIF()
ENDIF()

project(libnitrokey LANGUAGES C CXX VERSION 3.2.0)
set(CMAKE_CXX_STANDARD 14)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_CXX_EXTENSIONS OFF)


include(GNUInstallDirs)



IF (NOT CMAKE_BUILD_TYPE)
    IF(APPLE)
        # Issues occur when build with enabled optimizations
        set(CMAKE_BUILD_TYPE Debug)
    ELSE()
        set(CMAKE_BUILD_TYPE RelWithDebInfo)
    ENDIF()
ENDIF()
MESSAGE("${PROJECT_NAME}: Build type: ${CMAKE_BUILD_TYPE}")

include_directories(hidapi)
include_directories(include)
set(SOURCE_FILES
    include/command.h
    include/command_id.h
    include/cxx_semantics.h
    include/device.h
    include/device_proto.h
    include/dissect.h
    include/log.h
    include/misc.h
    include/NitrokeyManager.h
    include/stick10_commands.h
    include/stick20_commands.h
    include/CommandFailedException.h
    include/LibraryException.h
    include/LongOperationInProgressException.h
    include/stick10_commands_0.8.h
    command_id.cc
    device.cc
    log.cc
    misc.cc
    NitrokeyManager.cc
    NK_C_API.h
    NK_C_API.cc
        DeviceCommunicationExceptions.cpp)

set(BUILD_SHARED_LIBS ON CACHE BOOL "Build all libraries as shared")
add_library(nitrokey ${SOURCE_FILES})

IF(APPLE)
    include_directories(hidapi/hidapi)
    add_library(hidapi-libusb STATIC hidapi/mac/hid.c )
    target_link_libraries(hidapi-libusb "-framework CoreFoundation" "-framework IOKit")
    target_link_libraries(nitrokey hidapi-libusb)
ELSEIF(UNIX)
#    add_library(hidapi-libusb STATIC hidapi/libusb/hid.c )
    find_package(PkgConfig)
    pkg_search_module(HIDAPI_LIBUSB REQUIRED hidapi-libusb)
    target_compile_options(nitrokey PRIVATE ${HIDAPI_LIBUSB_CFLAGS})
    target_link_libraries(nitrokey ${HIDAPI_LIBUSB_LDFLAGS})
ELSEIF(WIN32)
    include_directories(hidapi/hidapi)
    add_library(hidapi-libusb STATIC hidapi/windows/hid.c )
    target_link_libraries(hidapi-libusb setupapi)
    target_link_libraries(nitrokey hidapi-libusb)
ENDIF()

set_target_properties(nitrokey PROPERTIES
	VERSION ${libnitrokey_VERSION}
	SOVERSION ${libnitrokey_VERSION_MAJOR})

OPTION(ERROR_ON_WARNING "Stop compilation on warning found (not supported for MSVC)" OFF)
if (NOT MSVC)
    set(COMPILE_FLAGS "-Wall -Wno-unused-function -Wcast-qual -Woverloaded-virtual")
    IF(NOT APPLE)
        if (ERROR_ON_WARNING)
            set(COMPILE_FLAGS "${COMPILE_FLAGS} -Werror")
        endif()
    ENDIF()
    SET_TARGET_PROPERTIES(nitrokey PROPERTIES COMPILE_FLAGS ${COMPILE_FLAGS} )
endif()

OPTION(NO_LOG "Compile without logging functionality and its strings (decreases size)" OFF)
IF (NO_LOG)
    SET_TARGET_PROPERTIES(nitrokey PROPERTIES COMPILE_DEFINITIONS "NO_LOG")
ENDIF()

OPTION(LOG_VOLATILE_DATA "Log volatile data (debug)" OFF)
IF (LOG_VOLATILE_DATA)
    SET_TARGET_PROPERTIES(nitrokey PROPERTIES COMPILE_DEFINITIONS "LOG_VOLATILE_DATA")
ENDIF()


file(GLOB LIB_INCLUDES "include/*.h" "NK_C_API.h")
install (FILES ${LIB_INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})
install (TARGETS nitrokey DESTINATION ${CMAKE_INSTALL_LIBDIR})

# configure and install pkg-config file
configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libnitrokey.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libnitrokey-1.pc @ONLY)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libnitrokey-1.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

OPTION(COMPILE_TESTS "Compile tests" FALSE)
OPTION(COMPILE_OFFLINE_TESTS "Compile offline tests" FALSE)

IF(COMPILE_OFFLINE_TESTS OR COMPILE_TESTS)
    include_directories(unittest/Catch/include)
    add_library(catch STATIC unittest/catch_main.cpp )
ENDIF()

IF(COMPILE_OFFLINE_TESTS)
    add_executable (test_offline unittest/test_offline.cc)
    target_link_libraries (test_offline ${EXTRA_LIBS} nitrokey catch)
    #run with 'make test' or 'ctest'
    include (CTest)
    add_test (runs test_offline)
ENDIF()

IF (COMPILE_TESTS)
    #needs connected PRO device for success
    #warning: it may delete data on the device
    add_executable (test_C_API unittest/test_C_API.cpp)
    target_link_libraries (test_C_API ${EXTRA_LIBS} nitrokey catch)

    add_executable (test2 unittest/test2.cc)
    target_link_libraries (test2 ${EXTRA_LIBS} nitrokey catch)

    add_executable (test3 unittest/test3.cc)
    target_link_libraries (test3 ${EXTRA_LIBS} nitrokey catch)

    add_executable (test_HOTP unittest/test_HOTP.cc)
    target_link_libraries (test_HOTP ${EXTRA_LIBS} nitrokey catch)

    add_executable (test1 unittest/test.cc)
    target_link_libraries (test1 ${EXTRA_LIBS} nitrokey catch)

    add_executable (test_issues unittest/test_issues.cc)
    target_link_libraries (test_issues ${EXTRA_LIBS} nitrokey catch)

ENDIF()



#SET(CPACK_GENERATOR
#        "DEB;RPM")
# build a CPack driven installer package
include (InstallRequiredSystemLibraries)
set (CPACK_RESOURCE_FILE_LICENSE
        "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
set (CPACK_PACKAGE_VERSION "${PROJECT_VERSION}")
include (CPack)

=== debian/changelog ===
libnitrokey (3.2-1ubuntu1) bionic; urgency=medium

  * Adjust symbols file for -O3.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 22 Mar 2018 16:07:50 -0700

libnitrokey (3.2-1) unstable; urgency=medium

  * New upstream release
    - Drop debian/patches/add_pkg_config.patch, included upstream
  * Add pkg-config to build-depends

 -- Scott Kitterman <scott@kitterman.com>  Tue, 16 Jan 2018 21:27:11 -0500

libnitrokey (3.1-2) unstable; urgency=medium

  * Correct license statement in debian/copyright
  * Update symbols files from build logs (Closes: #885242)
  * Add libhidapi-dev to libnitrokey-dev depends so pkg-config library
    detection works
  * Bump standards-version to 4.1.3 without further change

 -- Scott Kitterman <scott@kitterman.com>  Thu, 28 Dec 2017 11:00:03 -0500

libnitrokey (3.1-1) unstable; urgency=medium

  * Initial release (Closes: #885030)
  * Add debian/patches/add_pkg_config.patch from upstream so pkg-config can
    find the library (already used by some rdepends)

 -- Scott Kitterman <scott@kitterman.com>  Fri, 22 Dec 2017 20:01:45 -0500

=== debian/control ===
Source: libnitrokey
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Scott Kitterman <scott@kitterman.com>
Build-Depends: debhelper (>= 9.0.0), cmake, pkg-config, pkg-kde-tools, libhidapi-dev, libusb-1.0-0-dev
Standards-Version: 4.1.3
Section: libs
Homepage: https://github.com/Nitrokey/libnitrokey

Package: libnitrokey-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libnitrokey3 (= ${binary:Version}), libhidapi-dev, ${misc:Depends}
Description: library to communicate with Nitrokey stick devices (development)
 library to communicate with Nitrokey Pro and Storage devices in a clean and
 easy manner. Written in C++14, testable with py.test and Catch frameworks,
 with C API, Python access.
 .
 This package contains development headers needed when developing
 C++ applications that use libnitrokey

Package: libnitrokey3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: library to communicate with Nitrokey stick devices
 library to communicate with Nitrokey Pro and Storage devices in a clean and
 easy manner. Written in C++14, testable with py.test and Catch frameworks,
 with C API, Python access.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@ --with pkgkde_symbolshelper

## libnitrokey 3.3

=== debian/changelog ===
libnitrokey (3.3-2) unstable; urgency=medium

  [ Jan Luca Naumann ]
  * Fix installation path of udev rule.
    - install to /lib/udev/rules.d 

  [ Scott Kitterman ]
  * Upload to unstable
  * Add misc:Depends for libnitrokey-common
  * Add Multi-Arch: allowed for libnitrokey-common
  * Update libnitrokey3.symbols from build logs

 -- Scott Kitterman <scott@kitterman.com>  Tue, 22 May 2018 00:44:38 -0400

libnitrokey (3.3-1) experimental; urgency=medium

  * Add git repository for packaging:
    - Vcs-* in debian/control
  * New upstream release
    - Update debian/copyright
    - Update symbols file
  * Account for nitrokey udev rule being built from libnitrokey instead of
    nitrokey-app
    - Add udev to build-depends
    - Add new binary, libnitrokey-common for udev rule since it is arch
      independent and so can't be in a multi-arched library binary
    - libnitrokey-common replaces nitrokey-app << 1.3~
  * Bump standards-version to 4.1.4 without further change
  * Update symbols file to work with -03 optimizations (Closes: #893831)
  * Fix insecure-copyright-format-uri

 -- Scott Kitterman <scott@kitterman.com>  Mon, 30 Apr 2018 00:05:05 -0400

=== debian/control ===
--- 
+++ 
@@ -1,10 +1,11 @@
 Source: libnitrokey
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Scott Kitterman <scott@kitterman.com>
-Build-Depends: debhelper (>= 9.0.0), cmake, pkg-config, pkg-kde-tools, libhidapi-dev, libusb-1.0-0-dev
-Standards-Version: 4.1.3
+Maintainer: Scott Kitterman <scott@kitterman.com>
+Build-Depends: debhelper (>= 9.0.0), cmake, pkg-config, pkg-kde-tools, libhidapi-dev, libusb-1.0-0-dev, udev
+Standards-Version: 4.1.4
 Section: libs
+Vcs-Git: https://salsa.debian.org/kitterman/libnitrokey.git
+Vcs-Browser: https://salsa.debian.org/kitterman/libnitrokey
 Homepage: https://github.com/Nitrokey/libnitrokey
 
 Package: libnitrokey-dev
@@ -23,8 +24,21 @@
 Package: libnitrokey3
 Architecture: any
 Multi-Arch: same
-Depends: ${shlibs:Depends}, ${misc:Depends}
+Depends: ${shlibs:Depends}, ${misc:Depends}, libnitrokey-common
 Description: library to communicate with Nitrokey stick devices
  library to communicate with Nitrokey Pro and Storage devices in a clean and
  easy manner. Written in C++14, testable with py.test and Catch frameworks,
  with C API, Python access.
+
+Package: libnitrokey-common
+Architecture: all
+Multi-Arch: allowed
+Replaces: nitrokey-app (<< 1.3~)
+Depends: ${misc:Depends}
+Recommends: libnitrokey3
+Description: architecture independent files for libnitrokey
+ library to communicate with Nitrokey Pro and Storage devices in a clean and
+ easy manner. Written in C++14, testable with py.test and Catch frameworks,
+ with C API, Python access.
+ .
+ Architecture independent files

## libnitrokey 3.4.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
     ENDIF()
 ENDIF()
 
-project(libnitrokey LANGUAGES C CXX VERSION 3.2.0)
+project(libnitrokey LANGUAGES C CXX VERSION 3.4.1)
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
@@ -42,23 +42,23 @@
 MESSAGE("${PROJECT_NAME}: Build type: ${CMAKE_BUILD_TYPE}")
 
 include_directories(hidapi)
-include_directories(include)
+include_directories(libnitrokey)
 set(SOURCE_FILES
-    include/command.h
-    include/command_id.h
-    include/cxx_semantics.h
-    include/device.h
-    include/device_proto.h
-    include/dissect.h
-    include/log.h
-    include/misc.h
-    include/NitrokeyManager.h
-    include/stick10_commands.h
-    include/stick20_commands.h
-    include/CommandFailedException.h
-    include/LibraryException.h
-    include/LongOperationInProgressException.h
-    include/stick10_commands_0.8.h
+    libnitrokey/command.h
+    libnitrokey/command_id.h
+    libnitrokey/cxx_semantics.h
+    libnitrokey/device.h
+    libnitrokey/device_proto.h
+    libnitrokey/dissect.h
+    libnitrokey/log.h
+    libnitrokey/misc.h
+    libnitrokey/NitrokeyManager.h
+    libnitrokey/stick10_commands.h
+    libnitrokey/stick20_commands.h
+    libnitrokey/CommandFailedException.h
+    libnitrokey/LibraryException.h
+    libnitrokey/LongOperationInProgressException.h
+    libnitrokey/stick10_commands_0.8.h
     command_id.cc
     device.cc
     log.cc
@@ -66,7 +66,9 @@
     NitrokeyManager.cc
     NK_C_API.h
     NK_C_API.cc
-        DeviceCommunicationExceptions.cpp)
+    DeviceCommunicationExceptions.cpp
+    ${CMAKE_CURRENT_BINARY_DIR}/version.cc
+    )
 
 set(BUILD_SHARED_LIBS ON CACHE BOOL "Build all libraries as shared")
 add_library(nitrokey ${SOURCE_FILES})
@@ -95,7 +97,7 @@
 
 OPTION(ERROR_ON_WARNING "Stop compilation on warning found (not supported for MSVC)" OFF)
 if (NOT MSVC)
-    set(COMPILE_FLAGS "-Wall -Wno-unused-function -Wcast-qual -Woverloaded-virtual")
+    set(COMPILE_FLAGS "-Wall -Wno-unused-function -Wcast-qual -Woverloaded-virtual -Wsign-compare -Wformat -Wformat-security")
     IF(NOT APPLE)
         if (ERROR_ON_WARNING)
             set(COMPILE_FLAGS "${COMPILE_FLAGS} -Werror")
@@ -115,9 +117,49 @@
 ENDIF()
 
 
-file(GLOB LIB_INCLUDES "include/*.h" "NK_C_API.h")
+OPTION(ADD_GIT_INFO "Add information about source code version from Git repository" TRUE)
+# generate version.h
+IF(ADD_GIT_INFO)
+execute_process(
+	COMMAND git describe --always --abbrev=4 HEAD
+	WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
+	RESULT_VARIABLE PROJECT_VERSION_GIT_RETURN_CODE
+	OUTPUT_VARIABLE PROJECT_VERSION_GIT
+	OUTPUT_STRIP_TRAILING_WHITESPACE
+	ERROR_QUIET
+)
+ENDIF()
+IF((NOT ${ADD_GIT_INFO}) OR (${PROJECT_VERSION_GIT_RETURN_CODE}))
+	SET(PROJECT_VERSION_GIT "unknown")
+	MESSAGE(STATUS "Setting Git library version to: " ${PROJECT_VERSION_GIT} )
+ENDIF()
+configure_file("version.cc.in" "version.cc" @ONLY)
+
+
+file(GLOB LIB_INCLUDES "libnitrokey/*.h" "NK_C_API.h")
 install (FILES ${LIB_INCLUDES} DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/${PROJECT_NAME})
 install (TARGETS nitrokey DESTINATION ${CMAKE_INSTALL_LIBDIR})
+
+IF(NOT WIN32)
+    # Install Nitrokey udev rules
+    IF(NOT DEFINED CMAKE_INSTALL_UDEVRULESDIR)
+        set(PKG_GET_UDEV_DIR ${PKG_CONFIG_EXECUTABLE} --variable=udevdir udev)
+        execute_process(COMMAND ${PKG_GET_UDEV_DIR} RESULT_VARIABLE ERR OUTPUT_VARIABLE CMAKE_INSTALL_UDEVRULESDIR OUTPUT_STRIP_TRAILING_WHITESPACE)
+        IF(${ERR})
+            set(CMAKE_INSTALL_UDEVRULESDIR "lib/udev/rules.d")
+        ELSE()
+            set(CMAKE_INSTALL_UDEVRULESDIR "${CMAKE_INSTALL_UDEVRULESDIR}/rules.d")
+        ENDIF()
+        string(REGEX REPLACE "^/" "" CMAKE_INSTALL_UDEVRULESDIR "${CMAKE_INSTALL_UDEVRULESDIR}")
+        string(REGEX REPLACE "^usr/" "" CMAKE_INSTALL_UDEVRULESDIR "${CMAKE_INSTALL_UDEVRULESDIR}") # usual prefix is usr/local
+        message(STATUS "Setting udev rules dir to ${CMAKE_INSTALL_UDEVRULESDIR}")
+    ENDIF()
+
+    install(FILES
+            ${CMAKE_CURRENT_SOURCE_DIR}/data/41-nitrokey.rules
+            DESTINATION ${CMAKE_INSTALL_UDEVRULESDIR}
+    )
+ENDIF()
 
 # configure and install pkg-config file
 configure_file(${CMAKE_CURRENT_SOURCE_DIR}/libnitrokey.pc.in ${CMAKE_CURRENT_BINARY_DIR}/libnitrokey-1.pc @ONLY)
@@ -127,38 +169,56 @@
 OPTION(COMPILE_OFFLINE_TESTS "Compile offline tests" FALSE)
 
 IF(COMPILE_OFFLINE_TESTS OR COMPILE_TESTS)
-    include_directories(unittest/Catch/include)
+    find_package(PkgConfig)
+    IF(PKG_CONFIG_FOUND)
+        pkg_check_modules(CATCH2 catch)
+    ENDIF()
+
+    if (CATCH2_FOUND)
+        message(STATUS "Found system Catch2, not using bundled version")
+        add_compile_options(${CATCH2_CFLAGS})
+    ELSE()
+        message(STATUS "Did NOT find system Catch2, instead using bundled version")
+        include_directories(unittest/Catch/single_include)
+    ENDIF()
+
     add_library(catch STATIC unittest/catch_main.cpp )
 ENDIF()
 
 IF(COMPILE_OFFLINE_TESTS)
     add_executable (test_offline unittest/test_offline.cc)
     target_link_libraries (test_offline ${EXTRA_LIBS} nitrokey catch)
+    SET_TARGET_PROPERTIES(test_offline PROPERTIES COMPILE_FLAGS ${COMPILE_FLAGS} )
     #run with 'make test' or 'ctest'
     include (CTest)
     add_test (runs test_offline)
+
+    add_executable(test_minimal unittest/test_minimal.c)
+    target_link_libraries(test_minimal ${EXTRA_LIBS} nitrokey)
+    add_test(minimal test_minimal)
 ENDIF()
 
 IF (COMPILE_TESTS)
-    #needs connected PRO device for success
-    #warning: it may delete data on the device
-    add_executable (test_C_API unittest/test_C_API.cpp)
-    target_link_libraries (test_C_API ${EXTRA_LIBS} nitrokey catch)
-
-    add_executable (test2 unittest/test2.cc)
-    target_link_libraries (test2 ${EXTRA_LIBS} nitrokey catch)
-
-    add_executable (test3 unittest/test3.cc)
-    target_link_libraries (test3 ${EXTRA_LIBS} nitrokey catch)
-
-    add_executable (test_HOTP unittest/test_HOTP.cc)
-    target_link_libraries (test_HOTP ${EXTRA_LIBS} nitrokey catch)
-
-    add_executable (test1 unittest/test.cc)
-    target_link_libraries (test1 ${EXTRA_LIBS} nitrokey catch)
-
-    add_executable (test_issues unittest/test_issues.cc)
-    target_link_libraries (test_issues ${EXTRA_LIBS} nitrokey catch)
+    #needs connected Pro/Storage devices for success
+    #WARNING: it may delete data on the device
+
+        SET(TESTS
+                unittest/test_C_API.cpp
+                unittest/test2.cc
+                unittest/test3.cc
+                unittest/test_HOTP.cc
+                unittest/test1.cc
+                unittest/test_issues.cc
+                unittest/test_multiple_devices.cc
+                unittest/test_strdup.cpp
+        )
+
+    foreach(testsourcefile ${TESTS} )
+        get_filename_component(testname ${testsourcefile} NAME_WE )
+        add_executable(${testname} ${testsourcefile} )
+        target_link_libraries(${testname} ${EXTRA_LIBS} nitrokey catch )
+        SET_TARGET_PROPERTIES(${testname} PROPERTIES COMPILE_FLAGS ${COMPILE_FLAGS} )
+    endforeach(testsourcefile)
 
 ENDIF()

=== debian/changelog ===
libnitrokey (3.4.1-4build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 23 Mar 2020 07:18:18 +0100

libnitrokey (3.4.1-4) unstable; urgency=medium

  * Update debian/copyright
  * Add lintian override for appstream-metadata-missing-modalias-provide
    because the correction is best done in nitrokey-app
  * Add Build-Depends-Package to libnitrokey3.symbols
  * Enable hardening flags

 -- Scott Kitterman <scott@kitterman.com>  Fri, 21 Dec 2018 12:05:16 -0500

libnitrokey (3.4.1-3) unstable; urgency=medium

  * Update symbols file from build logs

 -- Scott Kitterman <scott@kitterman.com>  Tue, 11 Dec 2018 23:46:42 -0500

libnitrokey (3.4.1-2) unstable; urgency=medium

  * Upload to unstable
  * Update symbols from build logs

 -- Scott Kitterman <scott@kitterman.com>  Tue, 11 Dec 2018 07:20:50 -0500

libnitrokey (3.4.1-1) experimental; urgency=medium

  * New upstream release
    - Refresh patch
    - Update symbols file from build log (Closes: #915462)
  * Bump standards-version to 4.2.1 without further change
  * Fix Multi-Arch specification for libnitrokey-common

 -- Scott Kitterman <scott@kitterman.com>  Fri, 07 Dec 2018 01:34:51 -0500

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/libnitrokey-$1.tar.gz/" \
    https://github.com/nitrokey/libnitrokey/tags (?:.*/)?v?(\d[\d\.]*)\.tar\.gz

## libnitrokey 3.5

=== debian/changelog ===
libnitrokey (3.5-3.3) unstable; urgency=high

  * Non-maintainer upload.
  * Source-only upload to make the fix into Bullseye. (Closes: 981672)

 -- Patryk Cisek <patryk@debian.org>  Wed, 03 Feb 2021 11:34:35 -0800

libnitrokey (3.5-3.2) unstable; urgency=medium

  * Non-maintainer upload.
  * Removed debian/libnitrokey3.symbols -- symbols would have to
    be maintained separately for each architecture.

 -- Patryk Cisek <patryk@debian.org>  Sat, 30 Jan 2021 09:17:04 -0800

libnitrokey (3.5-3.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Updated debian/libnitrokey3.symbols. (Closes: #966922)

 -- Patryk Cisek <patryk@debian.org>  Sat, 07 Nov 2020 13:37:07 -0800

libnitrokey (3.5-3) UNRELEASED; urgency=low

  * Trim trailing whitespace.
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.

 -- Debian Janitor <janitor@jelmer.uk>  Fri, 26 Jun 2020 06:30:05 -0000

libnitrokey (3.5-2) unstable; urgency=medium

  * Upload to unstable
  * Update symbols files from experimental build logs (Closes: #958313)
  * Switch to debhelper-compat and update to compat 12
  * Update standards-version to 4.5.0 without further change

 -- Scott Kitterman <scott@kitterman.com>  Thu, 07 May 2020 15:43:59 -0400

libnitrokey (3.5-1) experimental; urgency=medium

  * New upstream release
  * Update debiacn/copyright
  * Update symbols file

 -- Scott Kitterman <scott@kitterman.com>  Sat, 28 Sep 2019 09:56:40 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,8 @@
 Source: libnitrokey
 Priority: optional
 Maintainer: Scott Kitterman <scott@kitterman.com>
-Build-Depends: debhelper (>= 9.0.0), cmake, pkg-config, pkg-kde-tools, libhidapi-dev, libusb-1.0-0-dev, udev
-Standards-Version: 4.1.4
+Build-Depends: debhelper-compat (= 12), cmake, pkg-config, pkg-kde-tools, libhidapi-dev, libusb-1.0-0-dev, udev
+Standards-Version: 4.5.0
 Section: libs
 Vcs-Git: https://salsa.debian.org/kitterman/libnitrokey.git
 Vcs-Browser: https://salsa.debian.org/kitterman/libnitrokey
@@ -32,7 +32,7 @@
 
 Package: libnitrokey-common
 Architecture: all
-Multi-Arch: allowed
+Multi-Arch: foreign
 Replaces: nitrokey-app (<< 1.3~)
 Depends: ${misc:Depends}
 Recommends: libnitrokey3

=== debian/rules ===
--- 
+++ 
@@ -3,6 +3,7 @@
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
+export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
 %:
 	dh $@ --with pkgkde_symbolshelper

## libnitrokey 3.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
     ENDIF()
 ENDIF()
 
-project(libnitrokey LANGUAGES C CXX VERSION 3.4.1)
+project(libnitrokey LANGUAGES C CXX VERSION 3.6.0)
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)
@@ -73,6 +73,8 @@
 set(BUILD_SHARED_LIBS ON CACHE BOOL "Build all libraries as shared")
 add_library(nitrokey ${SOURCE_FILES})
 
+set(HIDAPI_LIBUSB_NAME hidapi-libusb)
+
 IF(APPLE)
     include_directories(hidapi/hidapi)
     add_library(hidapi-libusb STATIC hidapi/mac/hid.c )
@@ -81,7 +83,12 @@
 ELSEIF(UNIX)
 #    add_library(hidapi-libusb STATIC hidapi/libusb/hid.c )
     find_package(PkgConfig)
-    pkg_search_module(HIDAPI_LIBUSB REQUIRED hidapi-libusb)
+    IF(${CMAKE_SYSTEM_NAME} STREQUAL "FreeBSD")
+        pkg_search_module(HIDAPI_LIBUSB REQUIRED hidapi)
+        set(HIDAPI_LIBUSB_NAME hidapi)
+    ELSE()
+        pkg_search_module(HIDAPI_LIBUSB REQUIRED hidapi-libusb)
+    ENDIF()
     target_compile_options(nitrokey PRIVATE ${HIDAPI_LIBUSB_CFLAGS})
     target_link_libraries(nitrokey ${HIDAPI_LIBUSB_LDFLAGS})
 ELSEIF(WIN32)
@@ -129,10 +136,17 @@
 	ERROR_QUIET
 )
 ENDIF()
-IF((NOT ${ADD_GIT_INFO}) OR (${PROJECT_VERSION_GIT_RETURN_CODE}))
-	SET(PROJECT_VERSION_GIT "unknown")
-	MESSAGE(STATUS "Setting Git library version to: " ${PROJECT_VERSION_GIT} )
-ENDIF()
+# the version.h generation logic is tricky in a number of ways:
+# 1. git describe on a release tarball will always fail with
+#    a non-zero return code, usually 128
+# 2. If git is not installed, PROJECT_VERSION_GIT_RETURN_CODE
+#    will contain the string 'No such file or directory'
+# Hence fallback to PROJECT_VERSION when the return code is NOT 0.
+IF((NOT ${ADD_GIT_INFO}) OR (NOT ${PROJECT_VERSION_GIT_RETURN_CODE} STREQUAL "0"))
+	MESSAGE(STATUS "Setting fallback Git library version")
+	SET(PROJECT_VERSION_GIT "v${PROJECT_VERSION}")
+ENDIF()
+MESSAGE(STATUS "Setting Git library version to: " ${PROJECT_VERSION_GIT} )
 configure_file("version.cc.in" "version.cc" @ONLY)
 
 
@@ -171,7 +185,7 @@
 IF(COMPILE_OFFLINE_TESTS OR COMPILE_TESTS)
     find_package(PkgConfig)
     IF(PKG_CONFIG_FOUND)
-        pkg_check_modules(CATCH2 catch)
+        pkg_check_modules(CATCH2 catch2)
     ENDIF()
 
     if (CATCH2_FOUND)
@@ -209,8 +223,10 @@
                 unittest/test_HOTP.cc
                 unittest/test1.cc
                 unittest/test_issues.cc
+		unittest/test_memory.c
                 unittest/test_multiple_devices.cc
                 unittest/test_strdup.cpp
+                unittest/test_safe.cpp
         )
 
     foreach(testsourcefile ${TESTS} )
@@ -232,3 +248,12 @@
         "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
 set (CPACK_PACKAGE_VERSION "${PROJECT_VERSION}")
 include (CPack)
+
+# Build Doxygen documentation for the C API
+find_package(Doxygen)
+if (DOXYGEN_FOUND)
+    configure_file(${CMAKE_CURRENT_SOURCE_DIR}/Doxyfile.in ${CMAKE_CURRENT_BINARY_DIR}/Doxyfile @ONLY)
+    add_custom_target(doc ${DOXYGEN_EXECUTABLE} Doxyfile
+        WORKING_DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}
+        COMMENT "Generating C API documentation with Doxygen" VERBATIM)
+endif(DOXYGEN_FOUND)

=== unittest/requirements.txt ===
cffi
pytest
pytest-repeat
pytest-randomly
tqdm
oath

=== debian/changelog ===
libnitrokey (3.6-1) unstable; urgency=medium

  * New Maintainer
  * Bumped Standards-Version to 4.6.0
  * Bumped version in debian/watch to 4
  * Bumped debhelper compat version to 13
  * Added "Rules-Requires-Root: no" to debian/control

 -- Patryk Cisek <patryk@debian.org>  Thu, 09 Dec 2021 09:36:56 -0800

libnitrokey (3.6-0.1) unstable; urgency=medium

  * Non-maintainer upload.
  * New upstream release.

 -- Patryk Cisek <patryk@debian.org>  Thu, 19 Aug 2021 12:33:32 -0700

## libnitrokey 3.7

=== CMakeLists.txt ===
--- 
+++ 
@@ -21,7 +21,7 @@
     ENDIF()
 ENDIF()
 
-project(libnitrokey LANGUAGES C CXX VERSION 3.6.0)
+project(libnitrokey LANGUAGES C CXX VERSION 3.7.0)
 set(CMAKE_CXX_STANDARD 14)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 set(CMAKE_CXX_EXTENSIONS OFF)

=== debian/changelog ===
libnitrokey (3.7-1.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Use udevdir from udev.pc to determine udev rules install path.
    (Closes: #1057243)

 -- Chris Hofstaedtler <zeha@debian.org>  Thu, 21 Dec 2023 00:00:34 +0100

libnitrokey (3.7-1) unstable; urgency=medium

  * New upstream release.

 -- Patryk Cisek <patryk@debian.org>  Fri, 20 May 2022 08:30:38 -0700

=== debian/rules ===
--- 
+++ 
@@ -5,5 +5,7 @@
 #export DH_VERBOSE=1
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
+export deb_udevdir = $(shell pkg-config --variable=udevdir udev | sed s,^/,,)
+
 %:
 	dh $@ --with pkgkde_symbolshelper

=== debian/watch ===
version=4
opts="filenamemangle=s/(?:.*)?v?(\d[\d\.]*)\.tar\.gz/libnitrokey-$1.tar.gz/" \
    https://github.com/nitrokey/libnitrokey/tags (?:.*/)?v?(\d[\d\.]*)\.tar\.gz

## libnitrokey 3.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -240,13 +240,14 @@
 
 
 
-#SET(CPACK_GENERATOR
-#        "DEB;RPM")
-# build a CPack driven installer package
+SET(CPACK_GENERATOR
+        "DEB;RPM")
+    # build a CPack driven installer package
 include (InstallRequiredSystemLibraries)
 set (CPACK_RESOURCE_FILE_LICENSE
         "${CMAKE_CURRENT_SOURCE_DIR}/LICENSE")
 set (CPACK_PACKAGE_VERSION "${PROJECT_VERSION}")
+set (CPACK_PACKAGE_CONTACT "info@nitrokey.com")
 include (CPack)
 
 # Build Doxygen documentation for the C API

=== unittest/requirements.txt ===
cffi
pytest
pytest-repeat
pytest-randomly
tqdm
oath
hypothesis

=== debian/changelog ===
libnitrokey (3.8-1) unstable; urgency=medium

  * New Upstream Release (Closes: #1113177)
  * Forcing the use of cmake as a build system since upstream introduced
    the custom-built Makefile

 -- Patryk Cisek <patryk@debian.org>  Fri, 07 Nov 2025 12:38:10 -0800

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --with pkgkde_symbolshelper --buildsystem=cmake
